diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index 354264236..17dc9bef5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -1,9 +1,10 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.material.Material;
@@ -16,7 +17,6 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T> {
     public static boolean fancyGrass = false;
@@ -35,7 +35,7 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBdc bounds = this.block.getBounds();
         boolean didRender = isRetro() ? renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1) : renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         if (fancyGrass && !(this.retroBlockTextures.hasTexture() && isRetro())) {
@@ -47,68 +47,49 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        GL11.glColor4f(brightness, brightness, brightness, alpha);
-        float yOffset = 0.5F;
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
 
         AABBdc bounds = getBlockBoundsForItemRender();
-        GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
+        tessellator.setColor1i(0xFFFFFFFF);
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
-        tessellator.draw();
-        if (renderBlocks.useInventoryTint && !isRetro()) {
-            int l = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float f4 = (float) (l >> 16 & 0xff) / 255F;
-            float f8 = (float) (l >> 8 & 0xff) / 255F;
-            float f9 = (float) (l & 0xff) / 255F;
-            GL11.glColor4f(f4 * brightness, f8 * brightness, f9 * brightness, alpha);
-        }
-        tessellator.startDrawingQuads();
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
+
+
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
-        tessellator.draw();
         if (fancyGrass && !isRetro()) {
             useOverlay = true;
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
-            tessellator.draw();
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
-            tessellator.draw();
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
-            tessellator.draw();
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
-            tessellator.draw();
             useOverlay = false;
         }
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.draw();
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
index 0dd084c01..f87cedec6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -21,14 +20,10 @@ public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         // todo: yes, i know this is horrible.
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
         float yOffset = 0f;
         int meta = worldSource.getBlockData(tilePos);
 
@@ -71,7 +66,7 @@ public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
         double extTopMinV = texV;
         double extTopMaxV = texIndex.getSubIconV(onePix * 6);
 
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         // Render sides int
         tessellator.addVertexWithUV(intMaxX, intMinY, intMaxZ, extSideMinU, extSideMaxV);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
index ba1badcef..ce96b1683 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -18,18 +17,14 @@ public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         boolean isHanging = (meta & BlockLogicJarButterfly.MASK_HANGING) == 0;
         boolean isAngled = (meta & BlockLogicJarButterfly.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index afdd888df..92e56d6d3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -1,10 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLadder;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
@@ -17,19 +15,13 @@ public class BlockModelLadder<T extends BlockLogicLadder> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int data = worldSource.getBlockData(tilePos);
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, data);
         if (renderBlocks.overrideBlockTexture != null) {
             tex = renderBlocks.overrideBlockTexture;
         }
-        float brightness = 1.0f;
-        if (!LightmapHelper.isLightmapEnabled()) {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        } else {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
         double uMin = tex.getIconUMin();
         double uMax = tex.getIconUMax();
         double vMin = tex.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index 0c12ca9fe..1014e9247 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
@@ -17,18 +16,14 @@ public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         boolean isHanging = (meta & BlockLogicLanternFirefly.MASK_HANGING) == 0;
 //        boolean isAngled = (meta & BlockLogicLanternFirefly.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index f414a1ad3..e0ba0e1f2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -1,15 +1,13 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelLayer(Block<T> block) {
@@ -18,9 +16,10 @@ public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        GL11.glTranslatef(0, 0.25f, 0);
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(0, 0.25, 0);
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        tessellator.offsetTranslation(0, -0.25, 0);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index 5c213027b..e7a332456 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -36,15 +37,15 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         boolean invTint = renderBlocks.useInventoryTint;
         renderBlocks.useInventoryTint = !this.canBeRetro || !isRetro();
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
         renderBlocks.useInventoryTint = invTint;
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         if (this.canBeRetro && isRetro()) {
             return renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos, 1, 1, 1);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
index e2f5fd36b..1e57db3c8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
@@ -1,18 +1,17 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCacao;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected IconCoordinate[] growthStages = new IconCoordinate[]{
@@ -27,34 +26,27 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         super.render(tessellator, worldSource, tilePos);
 
         AABBdc bounds = this.block.getBounds();
 
         final int growthRate = BlockLogicLeavesCacao.getGrowthRate(worldSource.getBlockData(tilePos));
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            int lmc = this.block.getLightmapCoord(worldSource, tilePos);
-            if (this.block.emission > 0) {
-                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-            }
-            tessellator.setLightmapCoord(lmc);
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            if (this.block.emission > 0) {
-                brightness = 1.0f;
-            }
+        int lmc = this.block.getLightmapCoord(worldSource, tilePos);
+        if (this.block.emission > 0) {
+            lmc = LightmapHelper.setBlocklightValue(lmc, 15);
         }
+        tessellator.setLightmapCoord1i(lmc);
 
         final float cNorthSouth = 0.8F;
         final float cEastWest = 0.6F;
         if (growthRate > 0) {
             renderBlocks.overrideBlockTexture = this.growthStages[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)];
-            tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            tessellator.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             renderBlocks.renderNorthFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
             renderBlocks.renderSouthFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
-            tessellator.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            tessellator.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
             renderBlocks.renderEastFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
             renderBlocks.renderWestFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
             renderBlocks.overrideBlockTexture = null;
@@ -64,45 +56,32 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
         AABBdc bounds = this.block.getBounds();
 
         final IconCoordinate cacaoCoord = this.growthStages[BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1];
-        GL11.glColor4f(brightness, brightness, brightness, alpha);
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cacaoCoord);
         tessellator.draw();
-
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
index 8b0bbdaa1..7b4914e2e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
@@ -1,17 +1,16 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends BlockModelLeaves<T> {
     private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_overlay");
@@ -22,7 +21,7 @@ public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends Block
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         super.render(tessellator, worldSource, tilePos);
 
         int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockData(tilePos));
@@ -39,45 +38,32 @@ public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends Block
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
 
         AABBdc bounds = this.block.getBoundsRaw();
-
         IconCoordinate cherryCoord = this.grownCherryOverlay;
-        GL11.glColor4f(brightness, brightness, brightness, alpha);
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, cherryCoord);
         tessellator.draw();
-
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 1f38d5885..76ad9fb2b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -21,7 +20,7 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int data = worldSource.getBlockData(tilePos);
         int rotation = data & BlockLogicLever.MASK_ROTATION;
         boolean powered = (data & BlockLogicLever.MASK_POWERED) != 0;
@@ -63,16 +62,7 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
         if (!overrideTexture) {
             renderBlocks.overrideBlockTexture = null;
         }
-        float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            if (this.block.emission <= 0) {
-                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            }
-        }
-
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, data);
         if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
